"""
    Contains definitions of the custom errors used by this python
"""


class GwError(Exception):
    """
        Generic Glacsweb error message
    """
    pass


class GwConfigError(GwError):
    """
        Used when there is a problem loading/saving a config file
    """
    pass


class GwLevelError(GwError):
    """
        Used when there is a problem understand what's going on
        with levels
    """
    pass


class GwProbeTypeError(GwError):
    """
        Used when the type of the probe isn't known
    """
    pass


class GwCommsError(GwError):
    """
        Generic communication error
    """
    pass


class GwMspCommsError(GwCommsError):
    """
        Problem communicating with MSP
    """
    pass


class GwProbeCommsError(GwCommsError):
    """
        Problem communicating with Probe
    """
    pass


class GwProbeExecutionError(GwError):
    """
        Thrown when a probe fails to execute the command
    """
    pass


class GwNotImplementedError(GwError):
    """
        Thrown for something that hasn't yet been implemented
    """
    pass


class GwNotApplicableError(GwError):
    """
        For stuf that isn't applicable to the specified mode
    """
    pass


class GwModeError(GwError):
    """
        Used when some goes wrong understanding modes
    """
    pass


class GwRouteError(GwError):
    """
        Caused by a problem with routing tables
    """
    pass

class GwProbeTypeError(GwError):
    pass
