import gwutil

from variables import MSP_DATA_FILE
from iceCapeMapping import BATT_V
from gwlevels import IGNORE_V
from gwlogging import logger


def avg(conv):
    logger.debug("Calculating battery average")
    f = open(MSP_DATA_FILE, "r")
    total = 0
    count = 0
    ignore_count = 0
    for line in f:
        arr = line.split("\t")
        if  int(arr[1]) == gwutil.mask2number(BATT_V):
            logger.debug("BAT_V data line")
            batt_volts = conv.batV(float(arr[2]))
            logger.debug("%fV" % batt_volts)
            if batt_volts > IGNORE_V:
                total += batt_volts
                count += 1
            else:
                ignore_count += 1
        else:
            logger.debug("Other data line ignoring")
    f.close()
    avg = 0
    if ignore_count > 0:
        logger.warn("Ignored %s" % ignore_count)
    if count > 0:
        avg = total / count
        logger.info("Voltage average is %3.6f" % avg)
        logger.debug("Based on %d readings" % count)
    else:
        logger.error("No valid voltage readings taken.")
    return avg
