#!/usr/bin/env python

import iceCape
import gprs

from gwlogging import logger

from time import sleep

if __name__ == "__main__":
    IC = iceCape.iceCape()

    logger.info("Powering on GPRS modem")

    # Power on the gprs modem
    IC.turn_on_power_output(iceCape.GPRS)

    # Give the modem a few seconds to power up
    sleep(20)
    if not gprs.init(False):
        logger.error("Failed to connect to networks")
        #power off gprs modem
        IC.turn_off_power_output(iceCape.GPRS)
        exit(1)
    else:
        logger.info("GSM modem registered with GPRS service")
        sleep(10)
        gprs.connect()

        if gprs.up():
            logger.info("GPRS interface up")
        else:
            logger.critical("interface not come up")
            IC.turn_off_power_output(iceCape.GPRS)
            exit(2)
