#!/usr/bin/env python
"""
    Simple script to get and print accelerometer readings
"""
import iceCape
from conversions import conversions
from gwlogging import logger
from variables import BASE, REF, FARM, CAM
from sys import argv

__mode__ = None


def read_accelerometer(mode):
    """
        Will get and print instantaneous readings of accelerometers
    """
    ice = iceCape.iceCape()
    ice.output_on(iceCape.SENSE_EN)
    raw_x = ice.read_sensors(iceCape.X)
    raw_y = ice.read_sensors(iceCape.Y)
    raw_z = ice.read_sensors(iceCape.Z)
    ice.output_off(iceCape.SENSE_EN)
    print ("RAW X value: %d" % raw_x)
    print ("RAW Y value: %d" % raw_y)
    print ("RAW Z value: %d" % raw_z)
    conv = conversions(mode)


if __name__ == "__main__":
    for arg in argv[1:]:
        if arg == '-B':
            logger.info("Base mode activated")
            __mode__ = BASE
        elif arg == '-R':
            logger.info("Ref mode activated")
            __mode__ = REF
        elif arg == '-C':
            logger.info("Cam mode activated")
            __mode__ = CAM
            __camera__ = True
            __comms__ = False
        elif arg == '-F':
            logger.info("farm mode activated")
            __mode__ = FARM
        else:
            print "Useage: %s  -[B|R|F|C]" % (argv[0])
            print "\t-C: Camera only mode"
            print "\t-B: Base station mode - enables probes"
            print "\t-R: Reference station mode - disables probes"
            print ("\t-F: Farm station mode - only does comms stuff does not" +
                            " do any power management")
            exit(2)

    if __mode__ is None:
        logger.critical("Must set a mode")
        exit(1)
    read_accelerometer(__mode__)
